package ;
	import org.cove.ape.APEngine;import org.cove.ape.AbstractCollection;import org.cove.ape.AbstractConstraint;import org.cove.ape.AbstractItem;import org.cove.ape.AbstractParticle;import org.cove.ape.CircleParticle;import org.cove.ape.Collision;import org.cove.ape.CollisionDetector;import org.cove.ape.CollisionResolver;import org.cove.ape.Composite;import org.cove.ape.Group;import org.cove.ape.Interval;import org.cove.ape.MathUtil;import org.cove.ape.RectangleParticle;import org.cove.ape.RimParticle;import org.cove.ape.SpringConstraint;import org.cove.ape.SpringConstraintParticle;import org.cove.ape.Vector;import org.cove.ape.WheelParticle;

	class RectComposite extends Composite {
		public var pc(get_pc,null):CircleParticle;
		public var pa(get_pa,null):CircleParticle;


		private var cpA:CircleParticle;
		private var cpC:CircleParticle;

		public function new(ctr:Vector, colA:Int, colB:Int) {
			super();

			// just hard coding here for the purposes of the demo, you should pass
			// everything in the constructor to do it right.
			var rw:Float = 75;
			var rh:Float = 18;
			var rad:Float = 4;

			// going clockwise from left top..
			cpA = new CircleParticle(ctr.x-rw/2, ctr.y-rh/2, rad, true);
			var cpB:CircleParticle = new CircleParticle(ctr.x+rw/2, ctr.y-rh/2, rad, true);
			cpC = new CircleParticle(ctr.x+rw/2, ctr.y+rh/2, rad, true);
			var cpD:CircleParticle = new CircleParticle(ctr.x-rw/2, ctr.y+rh/2, rad, true);

			cpA.setStyle(0,0,0,colA);
			cpB.setStyle(0,0,0,colA);
			cpC.setStyle(0,0,0,colA);
			cpD.setStyle(0,0,0,colA);

			// by default all fixed particles are not repainted. untyped __is__(this,for) efficiency,
			// since it would be a waste to repaint a non moving particle. in this case
			// we are going to be rotating a group of fixed particles, so we'll turn on
			// always repaint for each one.
			cpA.alwaysRepaint = true;
			cpB.alwaysRepaint = true;
			cpC.alwaysRepaint = true;
			cpD.alwaysRepaint = true;

			var sprA:SpringConstraint = cast( new SpringConstraint(cpA,cpB,0.5,true,rad * 2),SpringConstraint);
			var sprB:SpringConstraint = cast( new SpringConstraint(cpB,cpC,0.5,true,rad * 2),SpringConstraint);
			var sprC:SpringConstraint = cast( new SpringConstraint(cpC,cpD,0.5,true,rad * 2),SpringConstraint);
			var sprD:SpringConstraint = cast( new SpringConstraint(cpD,cpA,0.5,true,rad * 2),SpringConstraint);

			sprA.setStyle(0,0,0,colA);
			sprB.setStyle(0,0,0,colA);
			sprC.setStyle(0,0,0,colA);
			sprD.setStyle(0,0,0,colA);

			// by default all fixed SpringConstraints are not cast(repainted,well). A
			// SpringConstraint will be fixed if both its attached Particles are
			// fixed.
			sprA.alwaysRepaint = true;
			sprB.alwaysRepaint = true;
			sprC.alwaysRepaint = true;
			sprD.alwaysRepaint = true;

			addParticle(cpA);
			addParticle(cpB);
			addParticle(cpC);
			addParticle(cpD);

			addConstraint(sprA);
			addConstraint(sprB);
			addConstraint(sprC);
			addConstraint(sprD);
		}

		public function get_pa():CircleParticle {
			return cpA;
		}

		public function get_pc():CircleParticle {
			return cpC;
		}
	}

