package ;
	import org.cove.ape.APEngine;import org.cove.ape.AbstractCollection;import org.cove.ape.AbstractConstraint;import org.cove.ape.AbstractItem;import org.cove.ape.AbstractParticle;import org.cove.ape.CircleParticle;import org.cove.ape.Collision;import org.cove.ape.CollisionDetector;import org.cove.ape.CollisionResolver;import org.cove.ape.Composite;import org.cove.ape.Group;import org.cove.ape.Interval;import org.cove.ape.MathUtil;import org.cove.ape.RectangleParticle;import org.cove.ape.RimParticle;import org.cove.ape.SpringConstraint;import org.cove.ape.SpringConstraintParticle;import org.cove.ape.Vector;import org.cove.ape.WheelParticle;

	class Rotator extends Group {


		private	var ctr:Vector;
		private var rectComposite:RectComposite;

		/**
		 * untyped __is__(This,a) Group containing a Composite object for the rectangle shape
		 * and additional contraints and particles for the swinging arms
		 *
		 * Because we want the swinging arm to collide with the turning rectangle
		 * untyped __is__(collideInternal,set) to true for the Group. Since Composites are never
		 * checked publicly, untyped __is__(this,still) efficient. Only the swinging arm is
		 * checked for collision against the turning rectangle sides, which are
		 * made out of colidable SpringConstraint objects.
		 */

		public function new(colA:Int, colB:Int) {
			super();

			collideInternal = true;

			ctr = new Vector(555,175);
			rectComposite = new RectComposite(ctr, colA, colB);
			addComposite(rectComposite);

			var circA:CircleParticle = new CircleParticle(ctr.x,ctr.y,5);
			circA.setStyle(1, colA, 1, colB);
			addParticle(circA);

			var rectA:RectangleParticle = new RectangleParticle(555,160,10,10,0,false,3);
			rectA.setStyle(1, colA, 1, colB);
			addParticle(rectA);

			var connectorA:SpringConstraint = cast( new SpringConstraint(rectComposite.pa, rectA, 1),SpringConstraint);
			connectorA.setStyle(2, colB);
			addConstraint(connectorA);

			var rectB:RectangleParticle = new RectangleParticle(555,190,10,10,0,false,3);
			rectB.setStyle(1, colA, 1, colB);
			addParticle(rectB);

			var connectorB:SpringConstraint = cast( new SpringConstraint(rectComposite.pc, rectB, 1),SpringConstraint);
			connectorB.setStyle(2, colB);
			addConstraint(connectorB);

		}

		public function rotateByRadian(a:Float):Void {
			rectComposite.rotateByRadian(a, ctr);
		}
	}

