package ;

	import org.cove.ape.APEngine;import org.cove.ape.AbstractCollection;import org.cove.ape.AbstractConstraint;import org.cove.ape.AbstractItem;import org.cove.ape.AbstractParticle;import org.cove.ape.CircleParticle;import org.cove.ape.Collision;import org.cove.ape.CollisionDetector;import org.cove.ape.CollisionResolver;import org.cove.ape.Composite;import org.cove.ape.Group;import org.cove.ape.Interval;import org.cove.ape.MathUtil;import org.cove.ape.RectangleParticle;import org.cove.ape.RimParticle;import org.cove.ape.SpringConstraint;import org.cove.ape.SpringConstraintParticle;import org.cove.ape.Vector;import org.cove.ape.WheelParticle;

	class Body extends Composite {
		public var right(get_right,null):AbstractParticle;
		public var left(get_left,null):AbstractParticle;
		public var center(get_center,null):AbstractParticle;


		private var top:AbstractParticle;
		private var rgt:AbstractParticle;
		private var lft:AbstractParticle;
		private var bot:AbstractParticle;
		private var ctr:AbstractParticle;

		public function new(
				left:AbstractParticle,
				right:AbstractParticle,
				height:Int,
				lineWeight:Float,
				lineColor:Int,
				lineAlpha:Float) {
			super();

			var cpx:Float = (right.px + left.px) / 2;
			var cpy:Float = right.py;


			rgt = new CircleParticle(right.px, right.py, 1);
			rgt.setStyle(3, lineColor, 1, lineColor, 1);
			lft = new CircleParticle(left.px, left.py, 1);
			lft.setStyle(3, lineColor, 1, lineColor, 1);

			ctr = new CircleParticle(cpx, cpy, 1);
			ctr.visible = false;
			top = new CircleParticle(cpx, cpy - height / 2, 1);
			top.visible = false;
			bot = new CircleParticle(cpx, cpy + height / 2, 1);
			bot.visible = false;



			// outer constraints
			var tr:SpringConstraint = cast( new SpringConstraint(top,rgt,1),SpringConstraint);
			tr.visible = false;
			var rb:SpringConstraint = cast( new SpringConstraint(rgt,bot,1),SpringConstraint);
			rb.visible = false;
			var bl:SpringConstraint = cast( new SpringConstraint(bot,lft,1),SpringConstraint);
			bl.visible = false;
			var lt:SpringConstraint = cast( new SpringConstraint(lft,top,1),SpringConstraint);
			lt.visible = false;

			// inner constrainst
			var ct:SpringConstraint = cast( new SpringConstraint(top,center,1),SpringConstraint);
			ct.visible = false;
			var cr:SpringConstraint = cast( new SpringConstraint(rgt,center,1),SpringConstraint);
			cr.setLine(lineWeight, lineColor, lineAlpha);
			var cb:SpringConstraint = cast( new SpringConstraint(bot,center,1),SpringConstraint);
			cb.visible = false;
			var cl:SpringConstraint = cast( new SpringConstraint(lft,center,1),SpringConstraint);
			cl.setLine(lineWeight, lineColor, lineAlpha);

			ctr.collidable = false;
			top.collidable = false;
			rgt.collidable = false;
			bot.collidable = false;
			lft.collidable = false;

			addParticle(ctr);
			addParticle(top);
			addParticle(rgt);
			addParticle(bot);
			addParticle(lft);

			addConstraint(tr);
			addConstraint(rb);
			addConstraint(bl);
			addConstraint(lt);

			addConstraint(ct);
			addConstraint(cr);
			addConstraint(cb);
			addConstraint(cl);
		}


		public function get_left():AbstractParticle {
			return lft;
		}

		public function get_center():AbstractParticle {
			return ctr;
		}

		public function get_right():AbstractParticle {
			return rgt;
		}
	}

