package blink.display;

#if flash

typedef DisplayObject = flash.display.DisplayObject;

#else true

import blink.display.Stage;
import blink.events.EventDispatcher;
import blink.display.DisplayObjectContainer;

class DisplayObject extends EventDispatcher
{
   public var x(GetX,SetX):Float;
   public var y(GetY,SetY):Float;
   public var name(default,default):String;
   public var width(default,default):Float;
   public var height(default,default):Float;
   public var visible(default,default):Bool;
   public var parent(GetParent,null):DisplayObjectContainer;
   public var stage(GetStage,null):Stage;
   public var rotation(GetRotation,SetRotation):Float;

   private var mX:Float;
   private var mY:Float;
   private var mTransformed:Bool;
   private var mRotation:Float;
   private var mParent:DisplayObjectContainer;

   public function new()
   {
      super();
      mX = mY = 0;
      mTransformed = false;
      mRotation = 0.0;
      //mParent = null;
      visible = true;
   }

   public function IsTransformed() { return mTransformed; }

   public function SetParent(inParent:DisplayObjectContainer)
      { mParent = inParent; }

   public function Render() { }

   public function GetX() { return mX; }
   public function GetParent() { return mParent; }
   public function GetY() { return mY; }
   public function SetX(inX:Float) { mX = inX; SetTransformed(); return mX; }
   public function SetY(inY:Float) { mY = inY; SetTransformed();return mY; }
   public function GetStage() { return blink.Lib.GetStage(); }
   public function AsContainer() : DisplayObjectContainer { return null; }

   public function SetRotation(inRotation:Float)
   {
      mRotation = inRotation;
      return mRotation;
   }
   public function GetRotation() { return mRotation; }


   public function SetTransformed()
   {
     mTransformed = mX!=0 || mY!=0 || mRotation!=0;
   }
   public function Transform()
   {
      nme_transform_view(mX,mY,mRotation);
   }
   static var nme_transform_view = neko.Lib.load("nme","nme_transform_view",3);
}

#end
